<template>
    <!-- 弹出框表单 -->
    <el-dialog :title="title" :visible.sync="open" width="90%" append-to-body>
        <el-form ref="form" :model="form" :rules="rules" label-width="120px">
            <el-row>
              <Field :span="20" label="姓名" prop="name" v-model="form.name" placeholder="请输入个人姓名"/>
              <Field :span="20" label="联系方式" prop="contact" v-model="form.contact" placeholder="请输入联系方式"/>
              <Field :span="20" label="证件类型" prop="idCardType" v-model="form.idCardType" type="radio" :enumData="dict.idCardType" placeholder="请输入证件类型"/>
              <Field :span="20" label="证件号码" prop="idCardNo" v-model="form.idCard" placeholder="请输入证件号码"/>
            </el-row>
        </el-form>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" v-if="pageInfo.type !== 'view'" @click="submitForm">确 定</el-button>
            <el-button @click="cancel">取 消</el-button>
        </div>
    </el-dialog>
</template>

<script>
    import form from "@/assets/mixins/formdialog";
    import dialogShow from "./dialogshow";
    export default {
        mixins: [form],
        components: {
            dialogShow ,
        },
        data() {
            return {
                // 子表选中数据
                checkedCareConstraintTrack: [],
                // 主动关怀服务追踪表格数据
                careConstraintTrackList: [],
                // 遮罩层
                loading: true,
                // 弹出层标题
                title: "主动关怀服务约束",
                // 是否显示弹出层
                open: false,
                toString:[
                    "createWay",
                    "track",
                    "idCardType",
                    "personId",
                ],
                // 表单校验
                rules: {

                    idCard: [
                        {required: true,message: "请输入身份证号码", trigger: "blur" },
                        {max: 18,message: "最多只能录入18个字符",trigger: "blur",},
                    ],

                }
            };
        },

        methods: {

            // 渲染前置处理
            beforeRender(data) {
                if(data.entity.careConstraintTrackList) {
                    this.careConstraintTrackList = data.entity.careConstraintTrackList;
                }
                return data
            },
            /** 编辑 */
            edit(row) {
                this.reset()
                this.query = { id: row.id };
                this.urls.currUrl ="care/constraint/edit";
                this.getData();
                this.pageInfo.type="edit"
                this.title = "修改主动关怀服务约束";
            },
            /** 新增 */
            add(row) {
                this.reset()
                this.urls.currUrl = "care/constraint/add";
                this.getData();
                this.pageInfo.type="add"
                this.title = "新增主动关怀服务约束";
            },
            /** 查看*/
            view(row) {
                this.reset()
                this.query = { id: row.id };
                this.urls.currUrl ="care/constraint/view";
                this.getData();
                this.pageInfo.type="view"
                this.title = "主动关怀服务约束详细";
            },
            /**取消按钮 */
            cancel() {
                this.open = false;
            },
            /**获取数据后弹框 */
            afterRender(data) {
                this.open = true;
            },

          beforeSubmit(data){
            data.name=this.dict['personId'][data.personId]
            return data;
          },

            afterSubmit(data) {
                this.open = false;
                this.$emit("ok");
            },

            // 表单重置
            reset() {
                this.form = {
                    siteId : null,
                    siteName : "",
                    personId : null,
                    name : "",
                    contact : "",
                    idCard : "",
                    idCardType : "居民身份证",
                    serviceFrequency : null,
                    trackingTime : null,
                    createWay : null,
                    operator : "",
                    track : 0,
                };
                this.resetForm("form");
            },
            resetForm(refName) {
                if (this.$refs[refName]) {
                    this.$refs[refName].resetFields();
                }
            },
        },
    };
</script>
